/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Getrusage.xs. Do not edit this file, edit Getrusage.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Getrusage.xs"
/* $Id: Getrusage.xs 11 2006-02-04 00:53:56Z taffy $ -*- c -*- */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include <string.h>
#include <stdio.h>
#include <assert.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/resource.h>

#define STORE_FIELD(format,data) string_store(hash, #data, format, res.data);
#define STORE_TIMEVAL(x) string_store(hash, #x, "%.6f", timeval_to_double(&res.x));
#define syscall(x) ({ int y = (x); if(y < 0) { perror(#x); }; y; })

static void string_store(HV* hash, const char *key, const char *fmt, ...) {
	char buffer[0x1000];
	va_list p;
	int len;

	assert(hash != NULL);
	assert(key != NULL);
	assert(fmt != NULL);

	va_start(p, fmt);
	len = vsnprintf(buffer, sizeof(buffer), fmt, p);
	va_end(p);

	hv_store(hash, key, strlen(key), newSVpv(buffer, len), 0);
}

static double timeval_to_double(const struct timeval *tv) {
	assert(tv != NULL);

	return tv->tv_sec + tv->tv_usec * 1e-6;
}

static void fetch_getrusage(HV *hash, int who) {
	struct rusage res;

	assert(hash != NULL);
	assert(who == RUSAGE_SELF || who == RUSAGE_CHILDREN);
	
	if(syscall(getrusage(who, &res)) >= 0) {
		STORE_TIMEVAL(ru_utime); /* leserlich etwas harmonieren^^ */
		STORE_TIMEVAL(ru_stime);

		STORE_FIELD("%ld", ru_maxrss);
		STORE_FIELD("%ld", ru_ixrss);
		STORE_FIELD("%ld", ru_idrss);
		STORE_FIELD("%ld", ru_isrss);
		STORE_FIELD("%ld", ru_minflt);
		STORE_FIELD("%ld", ru_majflt);
		STORE_FIELD("%ld", ru_nswap);
		STORE_FIELD("%ld", ru_inblock);
		STORE_FIELD("%ld", ru_oublock);
		STORE_FIELD("%ld", ru_msgsnd);
		STORE_FIELD("%ld", ru_msgrcv);
		STORE_FIELD("%ld", ru_nsignals);
		STORE_FIELD("%ld", ru_nvcsw);
		STORE_FIELD("%ld", ru_nivcsw);
	}
}

#line 79 "Getrusage.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 223 "Getrusage.c"

XS_EUPXS(XS_Unix__Getrusage_getrusage); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Unix__Getrusage_getrusage)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 74 "Getrusage.xs"
HV *hash;
#line 234 "Getrusage.c"
	SV *	RETVAL;
#line 76 "Getrusage.xs"
hash = newHV();
fetch_getrusage(hash, RUSAGE_SELF);
sv_2mortal((SV*) hash);
RETVAL = newRV_inc((SV*)hash);
#line 241 "Getrusage.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Unix__Getrusage_getrusage_children); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Unix__Getrusage_getrusage_children)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 86 "Getrusage.xs"
HV *hash;
#line 258 "Getrusage.c"
	SV *	RETVAL;
#line 88 "Getrusage.xs"
hash = newHV();
fetch_getrusage(hash, RUSAGE_CHILDREN);
sv_2mortal((SV*) hash);
RETVAL = newRV_inc((SV*)hash);
#line 265 "Getrusage.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Unix__Getrusage); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Unix__Getrusage)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Unix::Getrusage::getrusage", XS_Unix__Getrusage_getrusage);
        newXS_deffile("Unix::Getrusage::getrusage_children", XS_Unix__Getrusage_getrusage_children);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
